'------------------------------------------------------------------------
'---------------Smooth transition regression-----------------
'------------------------------------------------------------------------
%name=_this.@name
%variables=%name+" c "+@equaloption("variables")
%transition=@equaloption("transition")
if %variables+%transition=%name+" c " then
	%variables=%name+" c"
	%title1="Linear and changing variables:"
	%transition=""
	%title2="Transition variables:"
	%title3="Residual lags for LSTR-D and ESTR-D:"
	%lags="2"
	%lags_="2"
	%title4="Specific residual lag for LSTR-D and ESTR-D:"
	%exp="3"
	scalar ot=1
	scalar lstr=0
	scalar estr=0
	scalar lstr_d=0
	scalar estr_d=0
	scalar eva=0
	if @uidialog("Caption","STAR models","Text","TESTING","edit",%variables,%title1,50,"edit",%transition,%title2,50,"edit",%exp,"Expansion order:","edit",%lags,%title3,2,"edit",%lags_,%title4,20,"Text","ESTIMATION","Radio",ot,"Estimator of STR model","""NLS"" ""Maximum Likelihood"" ","Text","Estimate STR structure:","Check",lstr,"LSTR","Check",estr,"ESTR","Check",lstr_d,"LSTR-D","Check",estr_d,"ESTR-D","edit",%sv,"Vector object for starting values:","check",eva,"Evaluation","text","Written by: Nicolas Ronderos (2015).")=-1 then
		delete estr estr_d lstr lstr_d ot eva
		stop
	endif
else
	scalar ot=1
	scalar lstr=0
	scalar estr=0
	scalar lstr_d=0
	scalar estr_d=0
	scalar eva=0
	%exp=@equaloption("exp")
	%lags=@equaloption("lags")
	%lags_=@equaloption("s_lag")
	if @hasoption("logl")=1 then
		ot=2
		else
		ot=1
	endif
	lstr=@hasoption("lstr")
	estr=@hasoption("estr")
	lstr_d=@hasoption("lstr_d")
	estr_d=@hasoption("estr_d")
	%sv=@equaloption("sv")
	eva=@hasoption("evaluation")
	if %exp="" then
		%exp="3"
	endif
	if %lags="" then
		%lags="2"
	endif
	if %lags_="" then
		%lags_="2"
	endif
endif

if %variables=%name+" c" then
	@uiprompt("There is not any aditional regressor")
	delete estr estr_d lstr lstr_d ot eva
	stop
endif

if @val(%exp)>6 then
	@uiprompt("The maximum expansion is 6")
	delete estr estr_d lstr lstr_d ot eva
	stop
endif

if lstr+estr+lstr_d+estr_d<>0 and %sv="" then
	@uiprompt("Starting values must be provided for estimation")
	delete estr estr_d lstr lstr_d ot eva
	stop
endif

if lstr+estr<>0 and %transition="" then
	@uiprompt("Transition variable must be provided for estimation of LSTR and ESTR.")
	delete estr estr_d lstr lstr_d ot eva
	stop
endif

if %sv<>"" then
	if 2*@wcount(%variables)+1>@rows({%sv}) then
		@uiprompt("There are less starting values than coefficients. The vector dimension must be "+@str(2*@wcount(%variables)+1)+".")
		delete estr estr_d lstr lstr_d ot eva
		stop
	endif
endif

'----------------------Testing linearty against LSTR--------------------
%regressors=@wdrop(%variables,@word(%variables,1))
equation step1.ls {%name} {%regressors}
step1.makeresids
!SSR_0=@ssr

%regressors_nc=@wdrop(%regressors,@word(%regressors,1))
!m=@wcount(%regressors_nc)
for !i=1 to !m
	for !j=!i to !m
		%interaction=%interaction+" "+@word(%regressors_nc,!i)+"*"+@word(%regressors_nc,!j)
	next
next

'LM test 1
'H0: Phi_ij=0 for i=1,...,m; j=!i,...,m
equation step2.ls resid01 {%regressors} {%interaction}
!SSR_1=@ssr
scalar LM_1=@obs({%name})*(!SSR_0-!SSR_1)/!SSR_0
scalar pv_LM_1=@chisq(LM_1,!m*(!m+1)/2)

'LM test 2
'H0: Phi_ij=0 for i=1,...,m; j=!i,...,m Psi_j=0 for j=1,...,m
for !j=1 to !m
	%cubic=%cubic+" "+@word(%regressors_nc,!j)+"^3"
next
equation step3.ls resid01 {%regressors} {%interaction} {%cubic}
!SSR_2=@ssr
scalar LM_2=@obs({%name})*(!SSR_0-!SSR_2)/!SSR_0
scalar pv_LM_2=@chisq(LM_2,!m+!m*(!m+1)/2)

'LM test 3
'H0: Phi_dj=0 for j=!i,...,m
if %transition<>"" then
	for !d=1 to @wcount(%transition)
		for !j=1 to !m
			%t_interaction=%t_interaction+" "+@word(%transition,!d)+"*"+@word(%regressors_nc,!j)
		next
	next
	equation step4.ls resid01 {%regressors} {%t_interaction}
	!SSR_3=@ssr
	scalar LM_3=@obs({%name})*(!SSR_0-!SSR_3)/!SSR_0
	scalar pv_LM_3=@chisq(LM_3,!m)

'LM test 4
'H0: Phi_dj=Psi_dj=Kappa_dj=0 for j=1,...,m
	for !d=1 to @wcount(%transition)
		for !j=1 to !m
			%ft_interaction=%ft_interaction+" "+@word(%transition,!d)+"*"+@word(%regressors_nc,!j)+" ("+@word(%transition,!d)+"^2)*"+@word(%regressors_nc,!j)+" ("+@word(%transition,!d)+"^3)*"+@word(%regressors_nc,!j)
		next
	next
	equation step5.ls resid01 {%regressors} {%ft_interaction}
	!SSR_4=@ssr
	scalar LM_4=@obs({%name})*(!SSR_0-!SSR_4)/!SSR_0
	scalar pv_LM_4=@chisq(LM_4,3*!m)
endif

'----------------------Testing linearty against ESTR--------------------

'LM test 1
'H0: Psi_ij=0 for i,j=1,...,m; Phi_ij=0 for j=1,...,m; i=j,...,m
for !i=1 to !m
	for !j=1 to !m
		%estr_cubic=%estr_cubic+" "+@word(%regressors_nc,!i)+"*("+@word(%regressors_nc,!j)+"^2)"
	next
next
equation step6.ls resid01 {%regressors} {%estr_cubic} {%interaction}
!SSR_5=@ssr
scalar LM_5=@obs({%name})*(!SSR_0-!SSR_5)/!SSR_0
scalar pv_LM_5=@chisq(LM_5,!m*!m+!m*(!m+1)/2)

'LM test 2
if %transition<>"" then
	for !d=1 to @wcount(%transition)
		for !i=1 to !m
			%estr_interaction=%estr_interaction+" "+@word(%regressors_nc,!i)+"*("+@word(%transition,!d)+"^2)"+" "+@word(%regressors_nc,!i)+"*"+@word(%transition,!d)
		next
	next
	equation step7.ls resid01 {%regressors} {%estr_interaction}
	!SSR_6=@ssr
	scalar LM_6=@obs({%name})*(!SSR_0-!SSR_6)/!SSR_0
	scalar pv_LM_6=@chisq(LM_6,2*!m)
endif

'----------------------Testing linearty against LSTR-D--------------------

'LM test 1
'H0: Phi:ij=0 for i=1,...,m;j=1,...,h
!h=@val(%lags)
for !i=1 to !m
	for !j=1 to !h
		%bilinear=%bilinear+" "+@word(%regressors_nc,!i)+"*resid01("+@str(-!j)+")"
	next
next
equation step8.ls resid01 {%regressors} {%bilinear}
!SSR_7=@ssr
scalar LM_7=@obs({%name})*(!SSR_0-!SSR_7)/!SSR_0
scalar pv_LM_7=@chisq(LM_7,!m*!h)

'LM test 2
'H0: Phi_id=0 for i=1,...,m

for !i=1 to !m
	for !j=1 to @wcount(%lags_)
		%lstr_d=%lstr_d+" "+@word(%regressors_nc,!i)+"*resid01(-"+@word(%lags_,!j)+")"
	next
next
equation step9.ls resid01 {%regressors} {%lstr_d}
!SSR_8=@ssr
scalar LM_8=@obs({%name})*(!SSR_0-!SSR_8)/!SSR_0
scalar pv_LM_8=@chisq(LM_8,!m)

'----------------------Testing linearty against ESTR-D--------------------

'LM test 1
'H0: Phi:ij=0 for i=1,...,m;j=1,...,h
for !i=1 to !m
	for !j=1 to !h
		%e_bilinear=%e_bilinear+" "+@word(%regressors_nc,!i)+"*(resid01("+@str(-!j)+")^2)"
	next
next
equation step10.ls resid01 {%regressors} {%e_bilinear}
!SSR_9=@ssr
scalar LM_9=@obs({%name})*(!SSR_0-!SSR_9)/!SSR_0
scalar pv_LM_9=@chisq(LM_9,!m*!h)

'LM test 2
'H0: Phi_id=0 for i=1,...,m

for !i=1 to !m
	for !j=1 to @wcount(%lags_)
		%estr_d=%estr_d+" "+@word(%regressors_nc,!i)+"*(resid01(-"+@word(%lags_,!j)+")^2)"
	next
next
equation step11.ls resid01 {%regressors} {%estr_d}
!SSR_10=@ssr
scalar LM_10=@obs({%name})*(!SSR_0-!SSR_10)/!SSR_0
scalar pv_LM_10=@chisq(LM_10,!m)

'------------------------Test based on expansions----------------------
'H0: Phi_ijklno=0 for i=1,...,m;j=i,...,m;k=j,...,m;l=k,...,m;n=l,...,m;o=n,...,m (sixth-order Volterra expansion).
!exp=@val(%exp)
scalar dg=0
if !exp>=2 then
	for !i=1 to !m
		for !j=!i to !m
			dg=dg+1
			%expantion_2=%expantion_2+"  "+@word(%regressors_nc,!i)+"*"+@word(%regressors_nc,!j)
		next
	next
endif

if !exp>=3 then
	for !i=1 to !m
		for !j=!i to !m
			for !k=!j to !m
				dg=dg+1
				%expantion_3=%expantion_3+"  "+@word(%regressors_nc,!i)+"*"+@word(%regressors_nc,!j)+"*"+@word(%regressors_nc,!k)
			next
		next
	next
endif

if !exp>=4 then
	for !i=1 to !m
		for !j=!i to !m
			for !k=!j to !m
				for !l=!k to !m
					dg=dg+1
					%expantion_4=%expantion_4+"  "+@word(%regressors_nc,!i)+"*"+@word(%regressors_nc,!j)+"*"+@word(%regressors_nc,!k)+"*"+@word(%regressors_nc,!l)
				next
			next
		next
	next
endif

if !exp>=5 then
	for !i=1 to !m
		for !j=!i to !m
			for !k=!j to !m
				for !l=!k to !m
					for !n=!l to !m
						dg=dg+1
						%expantion_5=%expantion_5+"  "+@word(%regressors_nc,!i)+"*"+@word(%regressors_nc,!j)+"*"+@word(%regressors_nc,!k)+"*"+@word(%regressors_nc,!l)+"*"+@word(%regressors_nc,!n)
					next
				next
			next
		next
	next
endif

if !exp>=6 then
	for !i=1 to !m
		for !j=!i to !m
			for !k=!j to !m
				for !l=!k to !m
					for !n=!l to !m
						for !o=!n to !m
							dg=dg+1
							%expantion_6=%expantion_6+"  "+@word(%regressors_nc,!i)+"*"+@word(%regressors_nc,!j)+"*"+@word(%regressors_nc,!k)+"*"+@word(%regressors_nc,!l)+"*"+@word(%regressors_nc,!n)+"*"+@word(%regressors_nc,!o)
						next
					next
				next
			next
		next
	next
endif

equation step12.ls resid01 {%regressors} {%expantion_2} {%expantion_3} {%expantion_4} {%expantion_5} {%expantion_6}
!SSR_11=@ssr
scalar LM_11=@obs({%name})*(!SSR_0-!SSR_11)/!SSR_0
scalar pv_LM_11=@chisq(LM_11,dg+!m)

'---------------------------------Results table--------------------------------

%table = "nl_test" 'This type of command would be used for generating a new name if the object already exists.
if @isobject(%table) then 
	%table = @getnextname(%table)
endif

table {%table}
setcell({%table},1,1,"Tests on "+%name+". H0:Linearty.","l")
setcell({%table},3,1,"Ha:LSTR","l")
setcell({%table},5,2,"LM statistic","c")
setcell({%table},5,3,"P-value","c")
setcell({%table},7,1,"Unknown transition variable: Expansion order "+%exp,"l")
setcell({%table},7,2,lm_11,3)
setcell({%table},7,3,pv_lm_11,3)
setcell({%table},8,1,"Unknown transition variable","l")
setcell({%table},9,1,"Unknown transition variable: Cubic expantion","l")
setcolwidth({%table},1,38)
setline({%table},4)
setline({%table},6)

if %transition<>"" then
	setcell({%table},2,1,"Transition variable: "+%transition,"l")
	setcell({%table},10,1,"Transition variable","l")
	setcell({%table},11,1,"Transition variable: Cubic expantion","l")
	setline({%table},12)
	for !i=1 to 4
		if !i<= 2 then
                !j=!i+4
			setcell({%table},!i+18,2,lm_!j,3)
			setcell({%table},!i+18,3,pv_lm_!j,3)
			!u=!i+6
			setcell({%table},!i+27,2,lm_!u,3)
			setcell({%table},!i+27,3,pv_lm_!u,3)
			!g=!i+8
			setcell({%table},!i+36,2,lm_!g,3)
			setcell({%table},!i+36,3,pv_lm_!g,3)
		endif
		setcell({%table},!i+7,2,lm_!i,3)
		setcell({%table},!i+7,3,pv_lm_!i,3)
	next
	setcell({%table},14,1,"Transition variable: "+%transition,"l")
	setcell({%table},15,1,"Ha:ESTR","l")
	setline({%table},16)
	setcell({%table},17,2,"LM statistic","c")
	setcell({%table},17,3,"P-value","c")
	setline({%table},18)
	setcell({%table},19,1,"Unknown transition variable","l")
	setcell({%table},20,1,"Transition variable: Cubic expantion","l")	
	setline({%table},21)
	setcell({%table},23,1,"Transition variable: "+"Deviation from a linear path","l")
	setcell({%table},24,1,"Ha:LSTR-D or bilinearty","l")
	setline({%table},25)
	setcell({%table},26,2,"LM statistic","c")
	setcell({%table},26,3,"P-value","c")
	setline({%table},27)
	setcell({%table},28,1,"Unknown residual lag: "+%lags,"l")
	setcell({%table},29,1,"Specific residual lag: "+%lags_,"l")
	setline({%table},30)
	setcell({%table},32,1,"Transition variable: "+"Deviation from a linear path","l")
	setcell({%table},33,1,"Ha:ESTR-D or bilinearty","l")
	setline({%table},34)
	setcell({%table},35,2,"LM statistic","c")
	setcell({%table},35,3,"P-value","c")
	setline({%table},36)
	setcell({%table},37,1,"Unknown residual lag: "+%lags,"l")
	setcell({%table},38,1,"Specific residual lag: "+%lags_,"l")
	setline({%table},39)
	delete step4 step5 step7 step8 step9 step10 step11 lm_3 lm_4 lm_6 lm_7 lm_8 lm_9 lm_10 pv_lm_3 pv_lm_4 pv_lm_6 pv_lm_7 pv_lm_8 pv_lm_9 pv_lm_10
else
	setcell({%table},2,1,"Transition variable: "+"NA","l")
	setline({%table},10)
	for !i=1 to 2
		setcell({%table},!i+7,2,lm_!i,3)
		setcell({%table},!i+7,3,pv_lm_!i,3)
		!u=!i+6
		setcell({%table},!i+24,2,lm_!u,3)
		setcell({%table},!i+24,3,pv_lm_!u,3)
		!g=!i+8
		setcell({%table},!i+33,2,lm_!g,3)
		setcell({%table},!i+33,3,pv_lm_!g,3)
	next
	setcell({%table},12,1,"Transition variable: "+"NA","l")
	setcell({%table},13,1,"Ha:ESTR","l")
	setline({%table},14)
	setcell({%table},15,2,"LM statistic","c")
	setcell({%table},15,3,"P-Value","c")
	setline({%table},16)
	setcell({%table},17,1,"Unknown transition variable","l")
	setcell({%table},17,2,lm_5,3)
	setcell({%table},17,3,pv_lm_5,3)
	setline({%table},18)
	setcell({%table},20,1,"Transition variable: "+"Deviation from a linear path","l")
	setcell({%table},21,1,"Ha:LSTR-D or bilinearty","l")
	setline({%table},22)
	setcell({%table},23,2,"LM statistic","c")
	setcell({%table},23,3,"P-value","c")
	setline({%table},24)
	setcell({%table},25,1,"Unknown residual lag: "+%lags,"l")
	setcell({%table},26,1,"Specific residual lag: "+%lags_,"l")
	setline({%table},27)
	setcell({%table},29,1,"Transition variable: "+"Deviation from a linear path","l")
	setcell({%table},30,1,"Ha:ESTR-D or bilinearty","l")
	setline({%table},31)
	setcell({%table},32,2,"LM statistic","c")
	setcell({%table},32,3,"P-Value","c")
	setline({%table},33)
	setcell({%table},34,1,"Unknown residual lag: "+%lags,"l")
	setcell({%table},35,1,"Specific residual lag: "+%lags_,"l")
	setline({%table},36)
	delete step8 step9 step10 step11 lm_7 lm_8 lm_9 lm_10 pv_lm_7 pv_lm_8 pv_lm_9 pv_lm_10
endif
'----------------------------Transition variables test---------------------------
'Table 1
%tv_test=@wunique(%transition+%regressors_nc)
%table1= "tv_test"
if @isobject(%table1) then 
	%table1 = @getnextname(%table1)
endif
if !h>@wcount(%tv_test) then
	!max=!h
else
	!max=@wcount(%tv_test)
endif
table(!max+6,6) {%table1}
setcolwidth({%table1},1,20)
setcolwidth({%table1},4,17)
setcell({%table1},1,1,"Transition variable tests on: "+%tv_test+" and "+@str(!h)+" residual lags","l")
setcell({%table1},2,1,"H0: The transition variable is not significant (STR or STR-D)","l")
setline({%table1},3)
setcell({%table1},4,1,"Transition variable (STR)","c")
setcell({%table1},4,2,"F-statistic","c")
setcell({%table1},4,3,"P-value","c")
setcell({%table1},4,4,"Residual lag (STR-D)","c")
setcell({%table1},4,5,"F-statistic","c")
setcell({%table1},4,6,"P-value","c")
setline({%table1},5)
for !i=1 to @wcount(%tv_test)
	{%table1}(!i+5,1)=@word(%tv_test,!i)
next
for !i=1 to !h
	setcell({%table1},!i+5,4,!i,0)
next
setline({%table1},!max+6)
'Table 2
%tv_test=@wunique(%transition+%regressors_nc)
%table2= "s_test"
if @isobject(%table2) then 
	%table2=@getnextname(%table2)
endif
table(!max+6,10) {%table2}
setcolwidth({%table2},1,20)
setcolwidth({%table2},6,17)
setcell({%table2},1,1,"Structure F tests on: "+%tv_test+" and "+@str(!h)+" residual lags","l")
setcell({%table2},2,1,"Choice: LSTR , ESTR or Linear (10% of significance)","l")
setline({%table2},3)
setcell({%table2},4,1,"Transition variable (STR)","c")
setcell({%table2},4,2,"Structure","c")
setcell({%table2},4,3,"P value F1","c")
setcell({%table2},4,4,"P value F2","c")
setcell({%table2},4,5,"P value F3","c")
setcell({%table2},4,6,"Residual lag (STR-D)","c")
setcell({%table2},4,7,"Structure","c")
setcell({%table2},4,8,"P value F1","c")
setcell({%table2},4,9,"P value F2","c")
setcell({%table2},4,10,"P value F3","c")
setline({%table2},5)
for !i=1 to @wcount(%tv_test)
	{%table2}(!i+5,1)=@word(%tv_test,!i)
next
for !i=1 to !h
	setcell({%table2},!i+5,6,!i,0)
next
setline({%table2},!max+6)
'STR
%regress=@wunion(%regressors,%transition)
for !i=1 to @wcount(%tv_test)
	for !j=1 to !m
		if %regress=%regressors then
			%t_test=%t_test+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^3)*"+@word(%regressors_nc,!j)
			%t_test1=%t_test1+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)
			%t_test2=%t_test2+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)
			!dsf=@obs(resid01)-4*!m-1
			!q1=3*!m
			!q2=!m
			!q3=2*!m
		else  if !j=1 then
				%t_test=%t_test+" "+@word(%tv_test,!i)+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2) ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^3) ("+@word(%tv_test,!i)+"^3)*"+@word(%regressors_nc,!j)
				%t_test1=%t_test1+" "+@word(%tv_test,!i)+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2) ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)
				%t_test2=%t_test2+" "+@word(%tv_test,!i)+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)
				!dsf=@obs(resid01)-4*!m-4
				!q1=3*!m+3
				!q2=!m+1
				!q3=2*!m+2
			else
				%t_test=%t_test+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^3)*"+@word(%regressors_nc,!j)
				%t_test1=%t_test1+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)
				%t_test2=%t_test2+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)
			endif
		endif
		if !j=!m then
			equation t_test.ls resid01 {%regressors} {%t_test}
			!SSR_1=@ssr
			equation t_test.ls resid01 {%regressors}
			!SSR_0=@ssr
			!FS=((!SSR_0-!SSR_1)/!q1)/(!SSR_1/(!dsf))
			!FS_P=@fdist(!FS,!q1,!dsf)
			setcell({%table1},!i+5,2,!FS,3)
			setcell({%table1},!i+5,3,!FS_P,3)
			'Structure F1
			equation t_test.ls resid01 {%regressors} {%t_test1}
			!SSR_0=@ssr
			!FS=((!SSR_0-!SSR_1)/!q2)/(!SSR_1/(!dsf))
			!FS_P1=@fdist(!FS,!q2,!dsf)
			'Structure F2
			equation t_test.ls resid01 {%regressors} {%t_test2}
			!SSR_0=@ssr
			equation t_test.ls resid01 {%regressors} {%t_test1}
			!SSR_1=@ssr
			!FS=((!SSR_0-!SSR_1)/!q2)/(!SSR_1/(!dsf+!q2))
			!FS_P2=@fdist(!FS,!q2,!dsf+!q2)
			'Structure F3
			equation t_test.ls resid01 {%regressors}
			!SSR_0=@ssr
			equation t_test.ls resid01 {%regressors} {%t_test2}
			!SSR_1=@ssr
			!FS=((!SSR_0-!SSR_1)/!q2)/(!SSR_1/(!dsf+!q3))
			!FS_P3=@fdist(!FS,!q2,!dsf+!q3)
			setcell({%table2},!i+5,3,!FS_P1)
			setcell({%table2},!i+5,4,!FS_P2)
			setcell({%table2},!i+5,5,!FS_P3)
			if !FS_P1>!FS_P2 and !FS_P3>!FS_P2 then
				setcell({%table2},!i+5,2,"ESTR")
			else
				setcell({%table2},!i+5,2,"LSTR")
			endif
			vector(3) p_values_f(1,1)=!FS_P1
			vector(3) p_values_f(2,1)=!FS_P2
			vector(3) p_values_f(3,1)=!FS_P3
			if @min(p_values_f)>0.1 then
				setcell({%table2},!i+5,2,"Linear")
			endif
			%t_test=""
			%t_test1=""
			%t_test2=""
			if %regress<>%regressors then
				%regress=@wdrop(%regress,@word(%tv_test,!i))
			endif
		endif
	next
next

'STR-D
%tv_test=""
for !i=1 to !h
	%tv_test=%tv_test+" resid01("+@str(-!i)+") "
next
for !i=1 to @wcount(%tv_test)
	for !j=1 to !m
		if !j=1 then
			%t_test=%t_test+" "+@word(%tv_test,!i)+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2) ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^3) ("+@word(%tv_test,!i)+"^3)*"+@word(%regressors_nc,!j)
			%t_test1=%t_test1+" "+@word(%tv_test,!i)+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2) ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)
			%t_test2=%t_test2+" "+@word(%tv_test,!i)+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)
			!dsf=@obs(resid01)-4*!m-4
			!q1=3*!m+3
			!q2=!m+1
			!q3=2*!m+2
		else
			%t_test=%t_test+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^3)*"+@word(%regressors_nc,!j)
			%t_test1=%t_test1+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)+" ("+@word(%tv_test,!i)+"^2)*"+@word(%regressors_nc,!j)
			%t_test2=%t_test2+" "+@word(%tv_test,!i)+"*"+@word(%regressors_nc,!j)
		endif
		if !j=!m then
			equation t_test.ls resid01 {%regressors} {%t_test}
			!SSR_1=@ssr
			equation t_test.ls resid01 {%regressors}
			!SSR_0=@ssr
			!FS=((!SSR_0-!SSR_1)/!q1)/(!SSR_1/(!dsf))
			!FS_P=@fdist(!FS,!q1,!dsf)
			setcell({%table1},!i+5,5,!FS,3)
			setcell({%table1},!i+5,6,!FS_P,3)
			'Structure F1
			equation t_test.ls resid01 {%regressors} {%t_test1}
			!SSR_0=@ssr
			!FS=((!SSR_0-!SSR_1)/!q2)/(!SSR_1/(!dsf))
			!FS_P1=@fdist(!FS,!q2,!dsf)
			'Structure F2
			equation t_test.ls resid01 {%regressors} {%t_test2}
			!SSR_0=@ssr
			equation t_test.ls resid01 {%regressors} {%t_test1}
			!SSR_1=@ssr
			!FS=((!SSR_0-!SSR_1)/!q2)/(!SSR_1/(!dsf+!q2))
			!FS_P2=@fdist(!FS,!q2,!dsf+!q2)
			'Structure F3
			equation t_test.ls resid01 {%regressors}
			!SSR_0=@ssr
			equation t_test.ls resid01 {%regressors} {%t_test2}
			!SSR_1=@ssr
			!FS=((!SSR_0-!SSR_1)/!q2)/(!SSR_1/(!dsf+!q3))
			!FS_P3=@fdist(!FS,!q2,!dsf+!q3)
			setcell({%table2},!i+5,8,!FS_P1)
			setcell({%table2},!i+5,9,!FS_P2)
			setcell({%table2},!i+5,10,!FS_P3)
			if !FS_P1>!FS_P2 and !FS_P3>!FS_P2 then
				setcell({%table2},!i+5,7,"ESTR")
			else
				setcell({%table2},!i+5,7,"LSTR")
			endif
			vector(3) p_values_f(1,1)=!FS_P1
			vector(3) p_values_f(2,1)=!FS_P2
			vector(3) p_values_f(3,1)=!FS_P3
			if @min(p_values_f)>0.1 then
				setcell({%table2},!i+5,7,"Linear")
			endif
			%t_test=""
			%t_test1=""
			%t_test2=""
		endif
	next
next

%spool="Str_tests" 'Spool for saving the tests results.
if @isobject(%spool) then
%spool=@getnextname(%spool)
endif
spool {%spool}
{%spool}.options tree borders comments margins
{%spool}.insert(name="Str_test") {%table}
{%spool}.comment "Str_test" "STR Test"
{%spool}.insert(name="TV") {%table1}
{%spool}.comment "TV" "Transition variable test (STR or STR-D)."
{%spool}.insert(name="Structure") {%table2}
{%spool}.comment "Structure" "Structure test (LSTR or ESTR)"
delete {%table} {%table1} {%table2}
'--------------------------------Estimation---------------------------------
if ot=1 then
	%str_v="c(1)+"
	%str_v1="c("+@str(@wcount(%regressors)+1)+")+"
	for !v=2 to @wcount(%regressors)
		if !v<@wcount(%regressors) then
			%str_v=%str_v+"c("+@str(!v)+")*"+@word(%regressors,!v)+"+"
			%str_v1=%str_v1+"c("+@str(!v+@wcount(%regressors))+")*"+@word(%regressors,!v)+"+"
		else
			%str_v=%str_v+"c("+@str(!v)+")*"+@word(%regressors,!v)
			%str_v1=%str_v1+"c("+@str(!v+@wcount(%regressors))+")*"+@word(%regressors,!v)		
		endif
	next
	for !i=1 to @wcount(%transition)
		if !i<@wcount(%transition) then
			%str_t=%str_t+@word(%transition,!i)+"+"
		else
			%str_t=%str_t+@word(%transition,!i)
		endif
	next
	for !i=1 to @wcount(%transition)
		if !i<@wcount(%transition) then
			%estr_t=%estr_t+@word(%transition,!i)+"^2+"
		else
			%estr_t=%estr_t+@word(%transition,!i)+"^2"
		endif
	next
	for !i=1 to @wcount(%lags_)
		if !i<@wcount(%lags_) then
			%strd_t=%strd_t+"resid01(-"+@word(%lags_,!i)+")"+"+"
		else
			%strd_t=%strd_t+"resid01(-"+@word(%lags_,!i)+")"
		endif
	next
	for !i=1 to @wcount(%lags_)
		if !i<@wcount(%lags_) then
			%estrd_t=%estrd_t+"resid01(-"+@word(%lags_,!i)+")^2"+"+"
		else
			%estrd_t=%estrd_t+"resid01(-"+@word(%lags_,!i)+")^2"
		endif
	next
	if lstr=1 then
		%lstr="lstr"
		if @isobject(%lstr) then 
			%lstr= @getnextname(%lstr)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		!c2=2*!v
		if @wcount(%transition)>1 then
			string r_str=%str_v+"+"+"("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*("+%str_t+"-c("+@str(!c2)+"))))"
		else
			!var=@sqrt(@vars({%transition}))
			string r_str=%str_v+"+"+"("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*("+%str_t+"-c("+@str(!c2)+"))/!var))"
		endif
		genr dep={%name}
		equation {%lstr}.ls {%name}={r_str}
		if eva=1 then
			%eva1="transition_"+%lstr
			%eva2="function_"+%lstr
			if @wcount(%transition)>1 then
			genr {%eva1}=1/(1+@exp(c(!c1)*({%str_t}-c(!c2))))
			else
			genr {%eva1}=1/(1+@exp(-c(!c1)*({%str_t}-c(!c2))/!var))
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			stom({%str_t},variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=1/(1+@exp(-c(!c1)*(transition_variable-c(!c2))/!var))
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%transition
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (LSTR) as function of the transition variable"
			genr linearf_{%lstr}={%str_v}
			genr nonlinearf_{%lstr}=({%str_v1})/(1+@exp(-c(!c1)*({%str_t}-c(!c2))/!var))
			%total_fitted="fitted_"+%lstr
			genr {%total_fitted}=linearf_{%lstr}+nonlinearf_{%lstr}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%lstr}.line
			freeze(g5) nonlinearf_{%lstr}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%lstr
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5
			endif
		endif
		delete dep r_str
	endif
	if estr=1 then
		%estr="estr"
		if @isobject(%estr) then 
			%estr= @getnextname(%estr)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		!c2=2*!v
		if @wcount(%transition)>1 then
			string r_str=%str_v+"+"+"("+%str_v1+")*(1-@exp(-c("+@str(!c1)+")*("+%estr_t+"-c("+@str(!c2)+"))))" 
		else
			!var=@vars({%transition})
			string r_str=%str_v+"+"+"("+%str_v1+")*(1-@exp((-c("+@str(!c1)+")*("+%str_t+"-c("+@str(!c2)+"))^2)/!var))"
		endif
		genr dep={%name}
		equation {%estr}.ls {%name}={r_str}
		if eva=1 then
			%eva1="transition_"+%estr
			%eva2="function_"+%estr
			if @wcount(%transition)>1 then
			genr {%eva1}=(1-@exp(-c(!c1)*({%estr_t}-c(!c2)))) 
			else
			genr {%eva1}=(1-@exp(-c(!c1)*({%str_t}-c(!c2))^2/!var))
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			stom({%str_t},variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=(1-@exp(-c(!c1)*(transition_variable-c(!c2))^2/!var))
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%transition
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (ESTR) as function of the transition variable"
			genr linearf_{%estr}={%str_v}
			genr nonlinearf_{%estr}=({%str_v1})*(1-@exp((-c(!c1)*({%str_t}-c(!c2))^2)/!var))
			%total_fitted="fitted_"+%estr
			genr {%total_fitted}=linearf_{%estr}+nonlinearf_{%estr}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%estr}.line
			freeze(g5) nonlinearf_{%estr}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%estr
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5
			endif
		endif
		delete dep r_str
	endif
	if lstr_d=1 then
		%lstr_d="lstr_d"
		if @isobject(%lstr_d) then 
			%lstr_d= @getnextname(%lstr_d)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		if @wcount(%lags_)>1 then
			string r_str=%str_v+"+"+"("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*(("+%strd_t+")/@wcount(%lags_)))-1/2)"
		else
			!var=@sqrt(@vars(resid01))
			string r_str=%str_v+"+"+"("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*("+%strd_t+")/!var)-1/2)"
		endif
		genr dep={%name}
		equation {%lstr_d}.ls {%name}={r_str}
		if eva=1 then
			%eva1="transition_"+%lstr_d
			%eva2="function_"+%lstr_d
			if @wcount(%lags_)>1 then
			%prov=%strd_t+"/@wcount(%lags_)"
			genr {%eva1}=1/(1+@exp(-c(!c1)*({%prov})))-1/2
			else
			genr {%eva1}=1/(1+@exp(-c(!c1)*({%strd_t})/!var))-1/2
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			stom({%strd_t},variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=1/(1+@exp(-c(!c1)*(transition_variable)/!var))-1/2
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%lags_+" residual lag"
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (LSTR-D) as function of the transition variable"
			genr linearf_{%lstr_d}={%str_v}
			genr nonlinearf_{%lstr_d}=({%str_v1})/((1+@exp(-c(!c1)*({%strd_t})/!var))-1/2)
			%total_fitted="fitted_"+%lstr_d
			genr {%total_fitted}=linearf_{%lstr_d}+nonlinearf_{%lstr_d}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%lstr_d}.line
			freeze(g5) nonlinearf_{%lstr_d}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%lstr_d
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5
			endif
		endif
		delete dep r_str
	endif
	if estr_d=1 then
		%estr_d="estr_d"
		if @isobject(%estr_d) then 
			%estr_d= @getnextname(%estr_d)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		if @wcount(%lags_)>1 then
			string r_str=%str_v+"+"+"("+%str_v1+")*(1-@exp(-c("+@str(!c1)+")*(("+%estrd_t+")/@wcount(%lags_)))-1/2)"
		else
			!var=@vars(resid01)
			string r_str=%str_v+"+"+"("+%str_v1+")*(1-@exp(-c("+@str(!c1)+")*("+%estrd_t+")/!var)-1/2)"
		endif
		genr dep={%name}
		equation {%estr_d}.ls {%name}={r_str}
		if eva=1 then
			%eva1="transition_"+%estr_d
			%eva2="function_"+%estr_d
			if @wcount(%lags_)>1 then
			%prov=%estrd_t+"/@wcount(%lags_)"
			genr {%eva1}=(1-@exp(-c(!c1)*({%prov})))-1/2
			else
			genr {%eva1}=(1-@exp(-c(!c1)*({%estrd_t})/!var))-1/2
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			genr estrd_t={%strd_t}
			stom(estrd_t,variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=(1-@exp(-c(!c1)*(transition_variable^2)/!var))-1/2
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%lags_+" residual lag"
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (ESTR-D) as function of the transition variable"
			genr linearf_{%estr_d}={%str_v}
			genr nonlinearf_{%estr_d}=({%str_v1})*((1-@exp((-c(!c1)*({%estrd_t}))/!var))-1/2)
			%total_fitted="fitted_"+%estr_d
			genr {%total_fitted}=linearf_{%estr_d}+nonlinearf_{%estr_d}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%estr_d}.line
			freeze(g5) nonlinearf_{%estr_d}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%estr_d
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5 estrd_t
			endif
		endif
		delete dep r_str
	endif
else
	%str_v="-c(1)-"
	%str_v1="c("+@str(@wcount(%regressors)+1)+")+"
	for !v=2 to @wcount(%regressors)
		if !v<@wcount(%regressors) then
			%str_v=%str_v+"c("+@str(!v)+")*"+@word(%regressors,!v)+"-"
			%str_v1=%str_v1+"c("+@str(!v+@wcount(%regressors))+")*"+@word(%regressors,!v)+"+"
		else
			%str_v=%str_v+"c("+@str(!v)+")*"+@word(%regressors,!v)
			%str_v1=%str_v1+"c("+@str(!v+@wcount(%regressors))+")*"+@word(%regressors,!v)		
		endif
	next
	for !i=1 to @wcount(%transition)
		if !i<@wcount(%transition) then
			%str_t=%str_t+@word(%transition,!i)+"+"
		else
			%str_t=%str_t+@word(%transition,!i)
		endif
	next
	for !i=1 to @wcount(%transition)
		if !i<@wcount(%transition) then
			%estr_t=%estr_t+@word(%transition,!i)+"^2+"
		else
			%estr_t=%estr_t+@word(%transition,!i)+"^2"
		endif
	next
	for !i=1 to @wcount(%lags_)
		if !i<@wcount(%lags_) then
			%strd_t=%strd_t+"resid01(-"+@word(%lags_,!i)+")"+"+"
		else
			%strd_t=%strd_t+"resid01(-"+@word(%lags_,!i)+")"
		endif
	next
	for !i=1 to @wcount(%lags_)
		if !i<@wcount(%lags_) then
			%estrd_t=%estrd_t+"resid01(-"+@word(%lags_,!i)+")^2"+"+"
		else
			%estrd_t=%estrd_t+"resid01(-"+@word(%lags_,!i)+")^2"
		endif
	next
	if lstr=1 then
		%lstr="lstr"
		if @isobject(%lstr) then 
			%lstr= @getnextname(%lstr)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		!c2=2*!v
		!c3=!c2+1
		if @wcount(%transition)>1 then
		string r_str=%name+%str_v+"-("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*("+%str_t+"-c("+@str(!c2)+"))))"
		else
		!var=@sqrt(@vars({%transition}))
		string r_str=%name+%str_v+"-("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*("+%str_t+"-c("+@str(!c2)+"))/!var))"
		endif
		logl {%lstr}
		{%lstr}.append @logl logl
		{%lstr}.append res={r_str}
		{%lstr}.append var=c(!c3)
		{%lstr}.append logl=-(1/2)*@log(2*@acos(-1))-@log(var)-(1/2)*(res/var)^2
		{%lstr}.append @temp res var logl
		{%lstr}.append @byobs
		%page_s=@pagesmpl
		vector(@wcount(%regressors_nc)) obs_=0
		for !i=1 to @wcount(%regressors_nc)
			%reg_=@word(%regressors_nc,!i)
			obs_(!i)=@obs({%reg_})
		next
		!s=@dtoo(@word(@pagesmpl,1))+@dtoo(@word(@pagesmpl,2))-@min(obs_)+1
		!e=@dtoo(@word(@pagesmpl,2))
		%start=@otod(!s)
		%end=@otod(!e)
		smpl {%start} {%end}
		{%lstr}.ml(showopts,m=10000,c=1e-2)
		smpl {%page_s}
		if eva=1 then
			%eva1="transition_"+%lstr
			%eva2="function_"+%lstr
			if @wcount(%transition)>1 then
			genr {%eva1}=1/(1+@exp(c(!c1)*({%str_t}-c(!c2))))
			else
			genr {%eva1}=1/(1+@exp(-c(!c1)*({%str_t}-c(!c2))/!var))
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			stom({%str_t},variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=1/(1+@exp(-c(!c1)*(transition_variable-c(!c2))/!var))
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%transition
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (LSTR) as function of the transition variable"
			genr linearf_{%lstr}={%str_v}
			genr nonlinearf_{%lstr}=({%str_v1})/(1+@exp(-c(!c1)*({%str_t}-c(!c2))/!var))
			%total_fitted="fitted_"+%lstr
			genr {%total_fitted}=linearf_{%lstr}+nonlinearf_{%lstr}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%lstr}.line
			freeze(g5) nonlinearf_{%lstr}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%lstr
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5
			endif
		endif
		delete r_str obs_
	endif
	if estr=1 then
		%estr="estr"
		if @isobject(%estr) then 
			%estr= @getnextname(%estr)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		!c2=2*!v
		!c3=!c2+1
		if @wcount(%transition)>1 then
		string r_str=%name+%str_v+"-("+%str_v1+")*(1-@exp(-c("+@str(!c1)+")*(("+%estr_t+"-c("+@str(!c2)+")))))" 
		else
		!var=@vars({%transition})
		string r_str=%name+%str_v+"-("+%str_v1+")*(1-@exp(-c("+@str(!c1)+")*(("+%str_t+"-c("+@str(!c2)+"))^2)/!var))"
		endif
		logl {%estr}
		{%estr}.append @logl logl
		{%estr}.append res={r_str}
		{%estr}.append var=c(!c3)
		{%estr}.append logl=-(1/2)*@log(2*@acos(-1))-@log(var)-(1/2)*(res/var)^2
		{%estr}.append @temp res var logl
		{%estr}.append @byobs
		%page_s=@pagesmpl
		vector(@wcount(%regressors_nc)) obs_=0
		for !i=1 to @wcount(%regressors_nc)
			%reg_=@word(%regressors_nc,!i)
			obs_(!i)=@obs({%reg_})
		next
		!s=@dtoo(@word(@pagesmpl,1))+@dtoo(@word(@pagesmpl,2))-@min(obs_)+1
		!e=@dtoo(@word(@pagesmpl,2))
		%start=@otod(!s)
		%end=@otod(!e)
		smpl {%start} {%end}
		{%estr}.ml(showopts,m=10000,c=1e-2)
		smpl {%page_s}
		if eva=1 then
			%eva1="transition_"+%estr
			%eva2="function_"+%estr
			if @wcount(%transition)>1 then
			genr {%eva1}=(1-@exp(-c(!c1)*({%estr_t}-c(!c2)))) 
			else
			genr {%eva1}=(1-@exp(-c(!c1)*({%str_t}-c(!c2))^2/!var))
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			stom({%str_t},variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=(1-@exp(-c(!c1)*(transition_variable-c(!c2))^2/!var))
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%transition
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (ESTR) as function of the transition variable"
			genr linearf_{%estr}={%str_v}
			genr nonlinearf_{%estr}=({%str_v1})*(1-@exp((-c(!c1)*({%str_t}-c(!c2))^2)/!var))
			%total_fitted="fitted_"+%estr
			genr {%total_fitted}=linearf_{%estr}+nonlinearf_{%estr}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%estr}.line
			freeze(g5) nonlinearf_{%estr}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%estr
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5
			endif
		endif
		delete r_str obs_
	endif
	if lstr_d=1 then
		%lstr_d="lstr_d"
		if @isobject(%lstr_d) then 
			%lstr_d= @getnextname(%lstr_d)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		!c2=2*!v
		if @wcount(%lags_)>1 then
			string r_str=%str_v+"+"+"("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*(("+%strd_t+")/@wcount(%lags_)))-1/2)"
		else
			!var=@sqrt(@vars(resid01))
			string r_str=%str_v+"+"+"("+%str_v1+")/(1+@exp(-c("+@str(!c1)+")*("+%strd_t+")/!var)-1/2)"
		endif
		logl {%lstr_d}
		{%lstr_d}.append @logl logl
		{%lstr_d}.append res={r_str}
		{%lstr_d}.append var=c(!c2)
		{%lstr_d}.append logl=-(1/2)*@log(2*@acos(-1))-@log(var)-(1/2)*(res/var)^2
		{%lstr_d}.append @temp res var logl
		{%lstr_d}.append @byobs
		%page_s=@pagesmpl
		vector(@wcount(%regressors_nc)) obs_=0
		for !i=1 to @wcount(%regressors_nc)
			%reg_=@word(%regressors_nc,!i)
			obs_(!i)=@obs({%reg_})
		next
		!s=@dtoo(@word(@pagesmpl,1))+@val(@word(%lags_,@wcount(%lags_)))+@dtoo(@word(@pagesmpl,2))-@min(obs_)
		!e=@dtoo(@word(@pagesmpl,2))
		%start=@otod(!s)
		%end=@otod(!e)
		smpl {%start} {%end}
		{%lstr_d}.ml(showopts,m=10000,c=1e-2)
		smpl {%page_s}
		if eva=1 then
			%eva1="transition_"+%lstr_d
			%eva2="function_"+%lstr_d
			if @wcount(%lags_)>1 then
			%prov=%strd_t+"/@wcount(%lags_)"
			genr {%eva1}=1/(1+@exp(-c(!c1)*({%prov})))-1/2
			else
			genr {%eva1}=1/(1+@exp(-c(!c1)*({%strd_t})/!var))-1/2
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			stom({%strd_t},variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=1/(1+@exp(-c(!c1)*(transition_variable)/!var))-1/2
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%lags_+" residual lag"
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (LSTR-D) as function of the transition variable"
			genr linearf_{%lstr_d}={%str_v}
			genr nonlinearf_{%lstr_d}=({%str_v1})/((1+@exp(-c(!c1)*({%strd_t})/!var))-1/2)
			%total_fitted="fitted_"+%lstr_d
			genr {%total_fitted}=linearf_{%lstr_d}+nonlinearf_{%lstr_d}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%lstr_d}.line
			freeze(g5) nonlinearf_{%lstr_d}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%lstr_d
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5
			endif
		endif
		delete r_str obs_
	endif
	if estr_d=1 then
		%estr_d="estr_d"
		if @isobject(%estr_d) then 
			%estr_d= @getnextname(%estr_d)
		endif
		for !i=1 to @rows({%sv})
			c(!i)={%sv}(!i)
		next
		!c1=2*!v-1
		!c2=2*!v
		if @wcount(%lags_)>1 then
			string r_str=%str_v+"+"+"("+%str_v1+")*(1-@exp(-c("+@str(!c1)+")*(("+%estrd_t+")/@wcount(%lags_)))-1/2)"
		else
			!var=@vars(resid01)
			string r_str=%str_v+"+"+"("+%str_v1+")*(1-@exp(-c("+@str(!c1)+")*("+%estrd_t+")/!var)-1/2)"
		endif
		logl {%estr_d}
		{%estr_d}.append @logl logl
		{%estr_d}.append res={r_str}
		{%estr_d}.append var=c(!c2)
		{%estr_d}.append logl=-(1/2)*@log(2*@acos(-1))-@log(var)-(1/2)*(res/var)^2
		{%estr_d}.append @temp res var logl
		{%estr_d}.append @byobs
		%page_s=@pagesmpl
		vector(@wcount(%regressors_nc)) obs_=0
		for !i=1 to @wcount(%regressors_nc)
			%reg_=@word(%regressors_nc,!i)
			obs_(!i)=@obs({%reg_})
		next
		!s=@dtoo(@word(@pagesmpl,1))+@val(@word(%lags_,@wcount(%lags_)))+@dtoo(@word(@pagesmpl,2))-@min(obs_)
		!e=@dtoo(@word(@pagesmpl,2))
		%start=@otod(!s)
		%end=@otod(!e)
		smpl {%start} {%end}
		{%estr_d}.ml(showopts,m=10000,c=1e-2)
		smpl {%page_s}
		if eva=1 then
			%eva1="transition_"+%estr_d
			%eva2="function_"+%estr_d
			if @wcount(%lags_)>1 then
			%prov=%estrd_t+"/@wcount(%lags_)"
			genr {%eva1}=(1-@exp(-c(!c1)*({%prov})))-1/2
			else
			genr {%eva1}=(1-@exp(-c(!c1)*({%estrd_t})/!var))-1/2
			freeze(g1) {%eva1}.line
			g1.addtext(t) "Transition function as function of time"
			genr estrd_t={%strd_t}
			stom(estrd_t,variable_t)
			variable_t=@sort(variable_t)
			mtos(variable_t,transition_variable)
			genr {%eva2}=(1-@exp(-c(!c1)*(transition_variable^2)/!var))-1/2
			group transition_function transition_variable {%eva2}
			freeze(g2) transition_function.xyline
			%legend="Transition variable "+%lags_+" residual lag"
			g2.setelem(1) legend({%legend})
			g2.addtext(t) "Transition function (ESTR-D) as function of the transition variable"
			genr linearf_{%estr_d}={%str_v}
			genr nonlinearf_{%estr_d}=({%str_v1})*((1-@exp((-c(!c1)*({%estrd_t}))/!var))-1/2)
			%total_fitted="fitted_"+%estr_d
			genr {%total_fitted}=linearf_{%estr_d}+nonlinearf_{%estr_d}
			freeze(g3) {%total_fitted}.line
			%text="Fitted values"
			g3.addtext(t) %text
			freeze(g4) linearf_{%estr_d}.line
			freeze(g5) nonlinearf_{%estr_d}.line
			%text="Linear fitted values"
			g4.addtext(t) %text
			%text="Nonlinear fitted values"
			g5.addtext(t) %text
			%text="Evaluation_"+%estr_d
			graph {%text}.merge g1 g2 g3 g4 g5
			d variable_t transition_variable transition_function g1 g2 g3 g4 g5 estrd_t
			endif
		endif
		delete r_str obs_
	endif
endif
'--------------------------------------------------------------------------------------
delete resid01 step1 step2 step3 step6 step12 lm_1 lm_2 lm_5 lm_11 pv_lm_1 pv_lm_2 pv_lm_5 pv_lm_11 dg t_test estr estr_d lstr lstr_d ot eva p_values_f


